/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.223 Revision 1.370
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.223 2006/02/15 23:40:16 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.370 2011/12/02 10:22:41 ferringb Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
17
12inherit multilib portability 18inherit multilib portability user
13
14DEPEND="!bootstrap? ( sys-devel/patch )"
15# sys-apps/shadow is needed for useradd, etc, bug #94745.
16 19
17DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
18 21
19# Wait for the supplied number of seconds. If no argument is supplied, defaults 22if has "${EAPI:-0}" 0 1 2; then
20# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 23
21# outputting to a terminal, don't wait. For compatability purposes, the argument 24# @FUNCTION: epause
22# must be an integer greater than zero. 25# @USAGE: [seconds]
23# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 26# @DESCRIPTION:
27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
28# printing a message the user should probably be reading and often used in
29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
30# don't wait at all. Defined in EAPIs 0 1 and 2.
24epause() { 31epause() {
25 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
26 sleep ${1:-5}
27 fi
28} 33}
29 34
30# Beep the specified number of times (defaults to five). If our output 35# @FUNCTION: ebeep
31# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 36# @USAGE: [number of beeps]
32# don't beep. 37# @DESCRIPTION:
33# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 38# Issue the specified number of beeps (default of 5 beeps). Useful when
39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
34ebeep() { 42ebeep() {
35 local n 43 local n
36 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
37 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
38 echo -ne "\a" 46 echo -ne "\a"
39 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 47 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
40 echo -ne "\a" 48 echo -ne "\a"
41 sleep 1 49 sleep 1
42 done 50 done
43 fi 51 fi
44} 52}
45 53
46# This function generate linker scripts in /usr/lib for dynamic 54else
47# libs in /lib. This is to fix linking problems when you have
48# the .so in /lib, and the .a in /usr/lib. What happens is that
49# in some cases when linking dynamic, the .a in /usr/lib is used
50# instead of the .so in /lib due to gcc/libtool tweaking ld's
51# library search path. This cause many builds to fail.
52# See bug #4411 for more info.
53#
54# To use, simply call:
55#
56# gen_usr_ldscript libfoo.so
57#
58# Note that you should in general use the unversioned name of
59# the library, as ldconfig should usually update it correctly
60# to point to the latest version of the library present.
61#
62# <azarah@gentoo.org> (26 Oct 2002)
63#
64gen_usr_ldscript() {
65 local lib libdir=$(get_libdir)
66 # Just make sure it exists
67 dodir /usr/${libdir}
68 55
69 for lib in "${@}" ; do 56ebeep() {
70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
71 /* GNU ld script 58}
72 Since Gentoo has critical dynamic libraries
73 in /lib, and the static versions in /usr/lib,
74 we need to have a "fake" dynamic lib in /usr/lib,
75 otherwise we run into linking problems.
76 59
77 See bug http://bugs.gentoo.org/4411 for more info. 60epause() {
78 */ 61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
79 GROUP ( /${libdir}/${lib} ) 62}
80 END_LDSCRIPT 63
81 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
70# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
71# profile.
72if ! declare -F eqawarn >/dev/null ; then
73 eqawarn() {
74 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
75 :
76 }
77fi
78
79# @FUNCTION: ecvs_clean
80# @USAGE: [list of dirs]
81# @DESCRIPTION:
82# Remove CVS directories recursiveley. Useful when a source tarball contains
83# internal CVS directories. Defaults to $PWD.
84ecvs_clean() {
85 [[ -z $* ]] && set -- .
86 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
87 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
88}
89
90# @FUNCTION: esvn_clean
91# @USAGE: [list of dirs]
92# @DESCRIPTION:
93# Remove .svn directories recursiveley. Useful when a source tarball contains
94# internal Subversion directories. Defaults to $PWD.
95esvn_clean() {
96 [[ -z $* ]] && set -- .
97 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
98}
99
100# @FUNCTION: eshopts_push
101# @USAGE: [options to `set` or `shopt`]
102# @DESCRIPTION:
103# Often times code will want to enable a shell option to change code behavior.
104# Since changing shell options can easily break other pieces of code (which
105# assume the default state), eshopts_push is used to (1) push the current shell
106# options onto a stack and (2) pass the specified arguments to set.
107#
108# If the first argument is '-s' or '-u', we assume you want to call `shopt`
109# rather than `set` as there are some options only available via that.
110#
111# A common example is to disable shell globbing so that special meaning/care
112# may be used with variables/arguments to custom functions. That would be:
113# @CODE
114# eshopts_push -o noglob
115# for x in ${foo} ; do
116# if ...some check... ; then
117# eshopts_pop
118# return 0
119# fi
82 done 120# done
121# eshopts_pop
122# @CODE
123eshopts_push() {
124 # have to assume __ESHOPTS_SAVE__ isn't screwed with
125 # as a `declare -a` here will reset its value
126 local i=${#__ESHOPTS_SAVE__[@]}
127 if [[ $1 == -[su] ]] ; then
128 __ESHOPTS_SAVE__[$i]=$(shopt -p)
129 [[ $# -eq 0 ]] && return 0
130 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
131 else
132 __ESHOPTS_SAVE__[$i]=$-
133 [[ $# -eq 0 ]] && return 0
134 set "$@" || die "eshopts_push: bad options to set: $*"
135 fi
83} 136}
84 137
138# @FUNCTION: eshopts_pop
139# @USAGE:
140# @DESCRIPTION:
141# Restore the shell options to the state saved with the corresponding
142# eshopts_push call. See that function for more details.
143eshopts_pop() {
144 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
145 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
146 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
147 local s=${__ESHOPTS_SAVE__[$i]}
148 unset __ESHOPTS_SAVE__[$i]
149 if [[ ${s} == "shopt -"* ]] ; then
150 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
151 else
152 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
153 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
154 fi
155}
85 156
86# Default directory where patches are located 157# @VARIABLE: EPATCH_SOURCE
158# @DESCRIPTION:
159# Default directory to search for patches.
87EPATCH_SOURCE="${WORKDIR}/patch" 160EPATCH_SOURCE="${WORKDIR}/patch"
88# Default extension for patches 161# @VARIABLE: EPATCH_SUFFIX
162# @DESCRIPTION:
163# Default extension for patches (do not prefix the period yourself).
89EPATCH_SUFFIX="patch.bz2" 164EPATCH_SUFFIX="patch.bz2"
165# @VARIABLE: EPATCH_OPTS
166# @DESCRIPTION:
90# Default options for patch 167# Default options for patch:
168# @CODE
91# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 169# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
92# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 170# --no-backup-if-mismatch - do not leave .orig files behind
171# -E - automatically remove empty files
172# @CODE
93EPATCH_OPTS="-g0 --no-backup-if-mismatch" 173EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
174# @VARIABLE: EPATCH_EXCLUDE
175# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 176# List of patches not to apply. Note this is only file names,
95# and not the full path .. 177# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 178EPATCH_EXCLUDE=""
179# @VARIABLE: EPATCH_SINGLE_MSG
180# @DESCRIPTION:
97# Change the printed message for a single patch. 181# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 182EPATCH_SINGLE_MSG=""
183# @VARIABLE: EPATCH_MULTI_MSG
184# @DESCRIPTION:
99# Change the printed message for multiple patches. 185# Change the printed message for multiple patches.
100EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 186EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
101# Force applying bulk patches even if not following the style: 187# @VARIABLE: EPATCH_FORCE
102# 188# @DESCRIPTION:
103# ??_${ARCH}_foo.${EPATCH_SUFFIX} 189# Only require patches to match EPATCH_SUFFIX rather than the extended
104# 190# arch naming style.
105EPATCH_FORCE="no" 191EPATCH_FORCE="no"
106 192
107# This function is for bulk patching, or in theory for just one 193# @FUNCTION: epatch
108# or two patches. 194# @USAGE: [patches] [dirs of patches]
195# @DESCRIPTION:
196# epatch is designed to greatly simplify the application of patches. It can
197# process patch files directly, or directories of patches. The patches may be
198# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
199# the -p option as epatch will automatically attempt -p0 to -p5 until things
200# apply successfully.
109# 201#
110# It should work with .bz2, .gz, .zip and plain text patches. 202# If you do not specify any options, then epatch will default to the directory
111# Currently all patches should be the same format. 203# specified by EPATCH_SOURCE.
112# 204#
113# You do not have to specify '-p' option to patch, as it will 205# When processing directories, epatch will apply all patches that match:
114# try with -p0 to -p5 until it succeed, or fail at -p5. 206# @CODE
115# 207# if ${EPATCH_FORCE} != "yes"
116# Above EPATCH_* variables can be used to control various defaults,
117# bug they should be left as is to ensure an ebuild can rely on
118# them for.
119#
120# Patches are applied in current directory.
121#
122# Bulk Patches should preferibly have the form of:
123#
124# ??_${ARCH}_foo.${EPATCH_SUFFIX} 208# ??_${ARCH}_foo.${EPATCH_SUFFIX}
209# else
210# *.${EPATCH_SUFFIX}
211# @CODE
212# The leading ?? are typically numbers used to force consistent patch ordering.
213# The arch field is used to apply patches only for the host architecture with
214# the special value of "all" means apply for everyone. Note that using values
215# other than "all" is highly discouraged -- you should apply patches all the
216# time and let architecture details be detected at configure/compile time.
125# 217#
126# For example: 218# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
219# for patches to apply.
127# 220#
128# 01_all_misc-fix.patch.bz2 221# Refer to the other EPATCH_xxx variables for more customization of behavior.
129# 02_sparc_another-fix.patch.bz2
130#
131# This ensures that there are a set order, and you can have ARCH
132# specific patches.
133#
134# If you however give an argument to epatch(), it will treat it as a
135# single patch that need to be applied if its a file. If on the other
136# hand its a directory, it will set EPATCH_SOURCE to this.
137#
138# <azarah@gentoo.org> (10 Nov 2002)
139#
140epatch() { 222epatch() {
141 _epatch_draw_line() { 223 _epatch_draw_line() {
142 local i=0 str_length="" str_out="" 224 # create a line of same length as input string
143 225 [[ -z $1 ]] && set "$(printf "%65s" '')"
144 # Handle calls that do not have args, or wc not being installed ... 226 echo "${1//?/=}"
145 if [[ -z $1 ]] || ! type -p wc >/dev/null ; then
146 str_length=65
147 else
148 str_length=$(echo -n "$*" | wc -m)
149 fi
150
151 while ((i++ < ${str_length})) ; do
152 str_out="${str_out}="
153 done
154 echo ${str_out}
155
156 return 0
157 } 227 }
158 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
159 local PIPE_CMD=""
160 local STDERR_TARGET="${T}/$$.out"
161 local PATCH_TARGET="${T}/$$.patch"
162 local PATCH_SUFFIX=""
163 local SINGLE_PATCH="no"
164 local x=""
165 228
166 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 229 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
167 230
168 if [ "$#" -gt 1 ] 231 # Let the rest of the code process one user arg at a time --
169 then 232 # each arg may expand into multiple patches, and each arg may
233 # need to start off with the default global EPATCH_xxx values
234 if [[ $# -gt 1 ]] ; then
170 local m="" 235 local m
171 for m in "$@" ; do 236 for m in "$@" ; do
172 epatch "${m}" 237 epatch "${m}"
173 done 238 done
174 return 0 239 return 0
175 fi 240 fi
176 241
177 if [ -n "$1" -a -f "$1" ] 242 local SINGLE_PATCH="no"
178 then 243 # no args means process ${EPATCH_SOURCE}
244 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
245
246 if [[ -f $1 ]] ; then
179 SINGLE_PATCH="yes" 247 SINGLE_PATCH="yes"
180 248 set -- "$1"
181 local EPATCH_SOURCE="$1" 249 # Use the suffix from the single patch (localize it); the code
250 # below will find the suffix for us
182 local EPATCH_SUFFIX="${1##*\.}" 251 local EPATCH_SUFFIX=$1
183 252
184 elif [ -n "$1" -a -d "$1" ] 253 elif [[ -d $1 ]] ; then
185 then 254 # Some people like to make dirs of patches w/out suffixes (vim)
186 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 255 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
187 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 256
257 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
258 # Re-use EPATCH_SOURCE as a search dir
259 epatch "${EPATCH_SOURCE}/$1"
260 return $?
261
262 else
263 # sanity check ... if it isn't a dir or file, wtf man ?
264 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
265 echo
266 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
267 eerror
268 eerror " ${EPATCH_SOURCE}"
269 eerror " ( ${EPATCH_SOURCE##*/} )"
270 echo
271 die "Cannot find \$EPATCH_SOURCE!"
272 fi
273
274 local PIPE_CMD
275 case ${EPATCH_SUFFIX##*\.} in
276 xz) PIPE_CMD="xz -dc" ;;
277 lzma) PIPE_CMD="lzma -dc" ;;
278 bz2) PIPE_CMD="bzip2 -dc" ;;
279 gz|Z|z) PIPE_CMD="gzip -dc" ;;
280 ZIP|zip) PIPE_CMD="unzip -p" ;;
281 *) ;;
282 esac
283
284 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
285
286 local x
287 for x in "$@" ; do
288 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
289 # didn't match anything, ignore continue on
290 [[ ! -f ${x} ]] && continue
291
292 local patchname=${x##*/}
293
294 # Apply single patches, or forced sets of patches, or
295 # patches with ARCH dependant names.
296 # ???_arch_foo.patch
297 # Else, skip this input altogether
298 local a=${patchname#*_} # strip the ???_
299 a=${a%%_*} # strip the _foo.patch
300 if ! [[ ${SINGLE_PATCH} == "yes" || \
301 ${EPATCH_FORCE} == "yes" || \
302 ${a} == all || \
303 ${a} == ${ARCH} ]]
188 then 304 then
189 local EPATCH_SOURCE="$1/*" 305 continue
306 fi
307
308 # Let people filter things dynamically
309 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
310 # let people use globs in the exclude
311 eshopts_push -o noglob
312
313 local ex
314 for ex in ${EPATCH_EXCLUDE} ; do
315 if [[ ${patchname} == ${ex} ]] ; then
316 eshopts_pop
317 continue 2
318 fi
319 done
320
321 eshopts_pop
322 fi
323
324 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
325 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
326 einfo "${EPATCH_SINGLE_MSG}"
327 else
328 einfo "Applying ${patchname} ..."
329 fi
190 else 330 else
191 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 331 einfo " ${patchname} ..."
192 fi 332 fi
193 else 333
194 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 334 # most of the time, there will only be one run per unique name,
195 then 335 # but if there are more, make sure we get unique log filenames
196 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 336 local STDERR_TARGET="${T}/${patchname}.out"
197 then 337 if [[ -e ${STDERR_TARGET} ]] ; then
198 EPATCH_SOURCE="$1" 338 STDERR_TARGET="${T}/${patchname}-$$.out"
339 fi
340
341 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
342
343 # Decompress the patch if need be
344 local count=0
345 local PATCH_TARGET
346 if [[ -n ${PIPE_CMD} ]] ; then
347 PATCH_TARGET="${T}/$$.patch"
348 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
349
350 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
351 echo
352 eerror "Could not extract patch!"
353 #die "Could not extract patch!"
354 count=5
355 break
199 fi 356 fi
357 else
358 PATCH_TARGET=${x}
359 fi
200 360
361 # Check for absolute paths in patches. If sandbox is disabled,
362 # people could (accidently) patch files in the root filesystem.
363 # Or trigger other unpleasantries #237667. So disallow -p0 on
364 # such patches.
365 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
366 if [[ -n ${abs_paths} ]] ; then
367 count=1
368 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
369 fi
370 # Similar reason, but with relative paths.
371 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
372 if [[ -n ${rel_paths} ]] ; then
373 eqawarn "QA Notice: Your patch uses relative paths '../'."
374 eqawarn " In the future this will cause a failure."
375 eqawarn "${rel_paths}"
376 fi
377
378 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
379 while [[ ${count} -lt 5 ]] ; do
380 # Generate some useful debug info ...
381 (
382 _epatch_draw_line "***** ${patchname} *****"
201 echo 383 echo
202 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 384 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
385 echo
386 _epatch_draw_line "***** ${patchname} *****"
387 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
388 ret=$?
389 echo
390 echo "patch program exited with status ${ret}"
391 exit ${ret}
392 ) >> "${STDERR_TARGET}"
393
394 if [ $? -eq 0 ] ; then
395 (
396 _epatch_draw_line "***** ${patchname} *****"
397 echo
398 echo "ACTUALLY APPLYING ${patchname} ..."
399 echo
400 _epatch_draw_line "***** ${patchname} *****"
401 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
402 ret=$?
403 echo
404 echo "patch program exited with status ${ret}"
405 exit ${ret}
406 ) >> "${STDERR_TARGET}"
407
408 if [ $? -ne 0 ] ; then
409 echo
410 eerror "A dry-run of patch command succeeded, but actually"
411 eerror "applying the patch failed!"
412 #die "Real world sux compared to the dreamworld!"
413 count=5
414 fi
415 break
416 fi
417
418 : $(( count++ ))
419 done
420
421 # if we had to decompress the patch, delete the temp one
422 if [[ -n ${PIPE_CMD} ]] ; then
423 rm -f "${PATCH_TARGET}"
424 fi
425
426 if [[ ${count} -ge 5 ]] ; then
427 echo
428 eerror "Failed Patch: ${patchname} !"
429 eerror " ( ${PATCH_TARGET} )"
203 eerror 430 eerror
204 eerror " ${EPATCH_SOURCE}" 431 eerror "Include in your bugreport the contents of:"
205 eerror " ( ${EPATCH_SOURCE##*/} )" 432 eerror
433 eerror " ${STDERR_TARGET}"
206 echo 434 echo
207 die "Cannot find \$EPATCH_SOURCE!"
208 fi
209
210 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
211 fi
212
213 case ${EPATCH_SUFFIX##*\.} in
214 bz2)
215 PIPE_CMD="bzip2 -dc"
216 PATCH_SUFFIX="bz2"
217 ;;
218 gz|Z|z)
219 PIPE_CMD="gzip -dc"
220 PATCH_SUFFIX="gz"
221 ;;
222 ZIP|zip)
223 PIPE_CMD="unzip -p"
224 PATCH_SUFFIX="zip"
225 ;;
226 *)
227 PIPE_CMD="cat"
228 PATCH_SUFFIX="patch"
229 ;;
230 esac
231
232 if [ "${SINGLE_PATCH}" = "no" ]
233 then
234 einfo "${EPATCH_MULTI_MSG}"
235 fi
236 for x in ${EPATCH_SOURCE}
237 do
238 # New ARCH dependant patch naming scheme ...
239 #
240 # ???_arch_foo.patch
241 #
242 if [ -f ${x} ] && \
243 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
244 [ "${EPATCH_FORCE}" = "yes" ])
245 then
246 local count=0
247 local popts="${EPATCH_OPTS}"
248 local patchname=${x##*/}
249
250 if [ -n "${EPATCH_EXCLUDE}" ]
251 then
252 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
253 then
254 continue
255 fi
256 fi
257
258 if [ "${SINGLE_PATCH}" = "yes" ]
259 then
260 if [ -n "${EPATCH_SINGLE_MSG}" ]
261 then
262 einfo "${EPATCH_SINGLE_MSG}"
263 else
264 einfo "Applying ${patchname} ..."
265 fi
266 else
267 einfo " ${patchname} ..."
268 fi
269
270 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
271 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
272
273 # Allow for prefix to differ ... im lazy, so shoot me :/
274 while [ "${count}" -lt 5 ]
275 do
276 # Generate some useful debug info ...
277 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
278 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
279
280 if [ "${PATCH_SUFFIX}" != "patch" ]
281 then
282 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
283 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
284 else
285 PATCH_TARGET="${x}"
286 fi
287
288 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
289 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
290
291 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
292 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
293
294 if [ "${PATCH_SUFFIX}" != "patch" ]
295 then
296 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
297 then
298 echo
299 eerror "Could not extract patch!"
300 #die "Could not extract patch!"
301 count=5
302 break
303 fi
304 fi
305
306 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
307 then
308 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
309 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
310 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
311 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
312 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
313
314 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
315 _epatch_assert
316
317 if [ "$?" -ne 0 ]
318 then
319 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
320 echo
321 eerror "A dry-run of patch command succeeded, but actually"
322 eerror "applying the patch failed!"
323 #die "Real world sux compared to the dreamworld!"
324 count=5
325 fi
326
327 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
328
329 break
330 fi
331
332 count=$((count + 1))
333 done
334
335 if [ "${PATCH_SUFFIX}" != "patch" ]
336 then
337 rm -f ${PATCH_TARGET}
338 fi
339
340 if [ "${count}" -eq 5 ]
341 then
342 echo
343 eerror "Failed Patch: ${patchname} !"
344 eerror " ( ${PATCH_TARGET} )"
345 eerror
346 eerror "Include in your bugreport the contents of:"
347 eerror
348 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
349 echo
350 die "Failed Patch: ${patchname}!" 435 die "Failed Patch: ${patchname}!"
351 fi 436 fi
352 437
353 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 438 # if everything worked, delete the patch log
354 439 rm -f "${STDERR_TARGET}"
355 eend 0 440 eend 0
356 fi
357 done 441 done
358 if [ "${SINGLE_PATCH}" = "no" ] 442
359 then 443 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
360 einfo "Done with patching" 444 : # everything worked
445}
446
447# @FUNCTION: epatch_user
448# @USAGE:
449# @DESCRIPTION:
450# Applies user-provided patches to the source tree. The patches are
451# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
452# of these three directories to exist will be the one to use, ignoring
453# any more general directories which might exist as well.
454#
455# User patches are intended for quick testing of patches without ebuild
456# modifications, as well as for permanent customizations a user might
457# desire. Obviously, there can be no official support for arbitrarily
458# patched ebuilds. So whenever a build log in a bug report mentions that
459# user patches were applied, the user should be asked to reproduce the
460# problem without these.
461#
462# Not all ebuilds do call this function, so placing patches in the
463# stated directory might or might not work, depending on the package and
464# the eclasses it inherits and uses. It is safe to call the function
465# repeatedly, so it is always possible to add a call at the ebuild
466# level. The first call is the time when the patches will be
467# applied.
468#
469# Ideally, this function should be called after gentoo-specific patches
470# have been applied, so that their code can be modified as well, but
471# before calls to e.g. eautoreconf, as the user patches might affect
472# autotool input files as well.
473epatch_user() {
474 [[ $# -ne 0 ]] && die "epatch_user takes no options"
475
476 # Allow multiple calls to this function; ignore all but the first
477 local applied="${T}/epatch_user.applied"
478 [[ -e ${applied} ]] && return 2
479
480 # don't clobber any EPATCH vars that the parent might want
481 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
482 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
483 EPATCH_SOURCE=${base}/${CTARGET}/${check}
484 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
485 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
486 if [[ -d ${EPATCH_SOURCE} ]] ; then
487 EPATCH_SOURCE=${EPATCH_SOURCE} \
488 EPATCH_SUFFIX="patch" \
489 EPATCH_FORCE="yes" \
490 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
491 epatch
492 echo "${EPATCH_SOURCE}" > "${applied}"
493 return 0
361 fi 494 fi
495 done
496 echo "none" > "${applied}"
497 return 1
362} 498}
363 499
500# @FUNCTION: emktemp
501# @USAGE: [temp dir]
502# @DESCRIPTION:
364# Cheap replacement for when debianutils (and thus mktemp) 503# Cheap replacement for when debianutils (and thus mktemp)
365# does not exist on the users system 504# does not exist on the users system.
366# vapier@gentoo.org
367#
368# Takes just 1 optional parameter (the directory to create tmpfile in)
369emktemp() { 505emktemp() {
370 local exe="touch" 506 local exe="touch"
371 [[ $1 == -d ]] && exe="mkdir" && shift 507 [[ $1 == -d ]] && exe="mkdir" && shift
372 local topdir=$1 508 local topdir=$1
373 509
375 [[ -z ${T} ]] \ 511 [[ -z ${T} ]] \
376 && topdir="/tmp" \ 512 && topdir="/tmp" \
377 || topdir=${T} 513 || topdir=${T}
378 fi 514 fi
379 515
380 if [[ -z $(type -p mktemp) ]] ; then 516 if ! type -P mktemp > /dev/null ; then
517 # system lacks `mktemp` so we have to fake it
381 local tmp=/ 518 local tmp=/
382 while [[ -e ${tmp} ]] ; do 519 while [[ -e ${tmp} ]] ; do
383 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 520 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
384 done 521 done
385 ${exe} "${tmp}" || ${exe} -p "${tmp}" 522 ${exe} "${tmp}" || ${exe} -p "${tmp}"
386 echo "${tmp}" 523 echo "${tmp}"
387 else 524 else
525 # the args here will give slightly wierd names on BSD,
526 # but should produce a usable file on all userlands
388 if [[ ${exe} == "touch" ]] ; then 527 if [[ ${exe} == "touch" ]] ; then
389 [[ ${USERLAND} == "GNU" ]] \ 528 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
390 && exe="-p" \
391 || exe="-t"
392 else 529 else
393 [[ ${USERLAND} == "GNU" ]] \
394 && exe="-d" \
395 || exe="-dt"
396 fi
397 TMPDIR="${topdir}" mktemp ${exe} tmp 530 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
398 fi
399}
400
401# Small wrapper for getent (Linux), nidump (Mac OS X),
402# and pw (FreeBSD) used in enewuser()/enewgroup()
403# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
404# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
405#
406# egetent(database, key)
407egetent() {
408 case ${CHOST} in
409 *-darwin*)
410 case "$2" in
411 *[!0-9]*) # Non numeric
412 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
413 ;;
414 *) # Numeric
415 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
416 ;;
417 esac
418 ;;
419 *-freebsd*|*-dragonfly*)
420 local opts action="user"
421 [[ $1 == "passwd" ]] || action="group"
422
423 # lookup by uid/gid
424 if [[ $2 == [[:digit:]]* ]] ; then
425 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
426 fi
427
428 pw show ${action} ${opts} "$2" -q
429 ;;
430 *-netbsd*|*-openbsd*)
431 grep "$2:\*:" /etc/$1
432 ;;
433 *)
434 type -p nscd >& /dev/null && nscd -i "$1"
435 getent "$1" "$2"
436 ;;
437 esac
438}
439
440# Simplify/standardize adding users to the system
441# vapier@gentoo.org
442#
443# enewuser(username, uid, shell, homedir, groups, extra options)
444#
445# Default values if you do not specify any:
446# username: REQUIRED !
447# uid: next available (see useradd(8))
448# note: pass -1 to get default behavior
449# shell: /bin/false
450# homedir: /dev/null
451# groups: none
452# extra: comment of 'added by portage for ${PN}'
453enewuser() {
454 # get the username
455 local euser=$1; shift
456 if [[ -z ${euser} ]] ; then
457 eerror "No username specified !"
458 die "Cannot call enewuser without a username"
459 fi
460
461 # lets see if the username already exists
462 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then
463 return 0
464 fi
465 einfo "Adding user '${euser}' to your system ..."
466
467 # options to pass to useradd
468 local opts=
469
470 # handle uid
471 local euid=$1; shift
472 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then
473 if [[ ${euid} -gt 0 ]] ; then
474 if [[ ! -z $(egetent passwd ${euid}) ]] ; then
475 euid="next"
476 fi 531 fi
477 else
478 eerror "Userid given but is not greater than 0 !"
479 die "${euid} is not a valid UID"
480 fi 532 fi
481 else
482 euid="next"
483 fi
484 if [[ ${euid} == "next" ]] ; then
485 for euid in $(seq 101 999) ; do
486 [[ -z $(egetent passwd ${euid}) ]] && break
487 done
488 fi
489 opts="${opts} -u ${euid}"
490 einfo " - Userid: ${euid}"
491
492 # handle shell
493 local eshell=$1; shift
494 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
495 if [[ ! -e ${ROOT}${eshell} ]] ; then
496 eerror "A shell was specified but it does not exist !"
497 die "${eshell} does not exist in ${ROOT}"
498 fi
499 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
500 eerror "Do not specify ${eshell} yourself, use -1"
501 die "Pass '-1' as the shell parameter"
502 fi
503 else
504 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
505 [[ -x ${ROOT}${shell} ]] && break
506 done
507
508 if [[ ${shell} == "/dev/null" ]] ; then
509 eerror "Unable to identify the shell to use"
510 die "Unable to identify the shell to use"
511 fi
512
513 eshell=${shell}
514 fi
515 einfo " - Shell: ${eshell}"
516 opts="${opts} -s ${eshell}"
517
518 # handle homedir
519 local ehome=$1; shift
520 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
521 ehome="/dev/null"
522 fi
523 einfo " - Home: ${ehome}"
524 opts="${opts} -d ${ehome}"
525
526 # handle groups
527 local egroups=$1; shift
528 if [[ ! -z ${egroups} ]] ; then
529 local oldifs=${IFS}
530 local defgroup="" exgroups=""
531
532 export IFS=","
533 for g in ${egroups} ; do
534 export IFS=${oldifs}
535 if [[ -z $(egetent group "${g}") ]] ; then
536 eerror "You must add group ${g} to the system first"
537 die "${g} is not a valid GID"
538 fi
539 if [[ -z ${defgroup} ]] ; then
540 defgroup=${g}
541 else
542 exgroups="${exgroups},${g}"
543 fi
544 export IFS=","
545 done
546 export IFS=${oldifs}
547
548 opts="${opts} -g ${defgroup}"
549 if [[ ! -z ${exgroups} ]] ; then
550 opts="${opts} -G ${exgroups:1}"
551 fi
552 else
553 egroups="(none)"
554 fi
555 einfo " - Groups: ${egroups}"
556
557 # handle extra and add the user
558 local oldsandbox=${SANDBOX_ON}
559 export SANDBOX_ON="0"
560 case ${CHOST} in
561 *-darwin*)
562 ### Make the user
563 if [[ -z $@ ]] ; then
564 dscl . create /users/${euser} uid ${euid}
565 dscl . create /users/${euser} shell ${eshell}
566 dscl . create /users/${euser} home ${ehome}
567 dscl . create /users/${euser} realname "added by portage for ${PN}"
568 ### Add the user to the groups specified
569 local oldifs=${IFS}
570 export IFS=","
571 for g in ${egroups} ; do
572 dscl . merge /groups/${g} users ${euser}
573 done
574 export IFS=${oldifs}
575 else
576 einfo "Extra options are not supported on Darwin yet"
577 einfo "Please report the ebuild along with the info below"
578 einfo "eextra: $@"
579 die "Required function missing"
580 fi
581 ;;
582 *-freebsd*|*-dragonfly*)
583 if [[ -z $@ ]] ; then
584 pw useradd ${euser} ${opts} \
585 -c "added by portage for ${PN}" \
586 die "enewuser failed"
587 else
588 einfo " - Extra: $@"
589 pw useradd ${euser} ${opts} \
590 "$@" || die "enewuser failed"
591 fi
592 ;;
593
594 *-netbsd*)
595 if [[ -z $@ ]] ; then
596 useradd ${opts} ${euser} || die "enewuser failed"
597 else
598 einfo " - Extra: $@"
599 useradd ${opts} ${euser} "$@" || die "enewuser failed"
600 fi
601 ;;
602
603 *-openbsd*)
604 if [[ -z $@ ]] ; then
605 useradd -u ${euid} -s ${eshell} \
606 -d ${ehome} -c "Added by portage for ${PN}" \
607 -g ${egroups} ${euser} || die "enewuser failed"
608 else
609 einfo " - Extra: $@"
610 useradd -u ${euid} -s ${eshell} \
611 -d ${ehome} -c "Added by portage for ${PN}" \
612 -g ${egroups} ${euser} "$@" || die "enewuser failed"
613 fi
614 ;;
615
616 *)
617 if [[ -z $@ ]] ; then
618 useradd ${opts} ${euser} \
619 -c "added by portage for ${PN}" \
620 || die "enewuser failed"
621 else
622 einfo " - Extra: $@"
623 useradd ${opts} ${euser} "$@" \
624 || die "enewuser failed"
625 fi
626 ;;
627 esac
628
629 if [[ ! -e ${ROOT}/${ehome} ]] ; then
630 einfo " - Creating ${ehome} in ${ROOT}"
631 mkdir -p "${ROOT}/${ehome}"
632 chown ${euser} "${ROOT}/${ehome}"
633 chmod 755 "${ROOT}/${ehome}"
634 fi
635
636 export SANDBOX_ON=${oldsandbox}
637} 533}
638 534
639# Simplify/standardize adding groups to the system 535# @FUNCTION: edos2unix
640# vapier@gentoo.org 536# @USAGE: <file> [more files ...]
641# 537# @DESCRIPTION:
642# enewgroup(group, gid) 538# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
643# 539# to remove all of these text utilities from DEPEND variables because this
644# Default values if you do not specify any: 540# is a script based solution. Just give it a list of files to convert and
645# groupname: REQUIRED ! 541# they will all be changed from the DOS CRLF format to the UNIX LF format.
646# gid: next available (see groupadd(8))
647# extra: none
648enewgroup() {
649 # get the group
650 local egroup="$1"; shift
651 if [ -z "${egroup}" ]
652 then
653 eerror "No group specified !"
654 die "Cannot call enewgroup without a group"
655 fi
656
657 # see if group already exists
658 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
659 then
660 return 0
661 fi
662 einfo "Adding group '${egroup}' to your system ..."
663
664 # options to pass to useradd
665 local opts=
666
667 # handle gid
668 local egid="$1"; shift
669 if [ ! -z "${egid}" ]
670 then
671 if [ "${egid}" -gt 0 ]
672 then
673 if [ -z "`egetent group ${egid}`" ]
674 then
675 if [[ "${CHOST}" == *-darwin* ]]; then
676 opts="${opts} ${egid}"
677 else
678 opts="${opts} -g ${egid}"
679 fi
680 else
681 egid="next available; requested gid taken"
682 fi
683 else
684 eerror "Groupid given but is not greater than 0 !"
685 die "${egid} is not a valid GID"
686 fi
687 else
688 egid="next available"
689 fi
690 einfo " - Groupid: ${egid}"
691
692 # handle extra
693 local eextra="$@"
694 opts="${opts} ${eextra}"
695
696 # add the group
697 local oldsandbox="${SANDBOX_ON}"
698 export SANDBOX_ON="0"
699 case ${CHOST} in
700 *-darwin*)
701 if [ ! -z "${eextra}" ];
702 then
703 einfo "Extra options are not supported on Darwin/OS X yet"
704 einfo "Please report the ebuild along with the info below"
705 einfo "eextra: ${eextra}"
706 die "Required function missing"
707 fi
708
709 # If we need the next available
710 case ${egid} in
711 *[!0-9]*) # Non numeric
712 for egid in $(seq 101 999); do
713 [ -z "`egetent group ${egid}`" ] && break
714 done
715 esac
716 dscl . create /groups/${egroup} gid ${egid}
717 dscl . create /groups/${egroup} passwd '*'
718 ;;
719
720 *-freebsd*|*-dragonfly*)
721 case ${egid} in
722 *[!0-9]*) # Non numeric
723 for egid in $(seq 101 999); do
724 [ -z "`egetent group ${egid}`" ] && break
725 done
726 esac
727 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
728 ;;
729
730 *-netbsd*)
731 case ${egid} in
732 *[!0-9]*) # Non numeric
733 for egid in $(seq 101 999); do
734 [ -z "`egetent group ${egid}`" ] && break
735 done
736 esac
737 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
738 ;;
739
740 *)
741 groupadd ${opts} ${egroup} || die "enewgroup failed"
742 ;;
743 esac
744 export SANDBOX_ON="${oldsandbox}"
745}
746
747# Simple script to replace 'dos2unix' binaries
748# vapier@gentoo.org
749#
750# edos2unix(file, <more files> ...)
751edos2unix() { 542edos2unix() {
752 for f in "$@" 543 [[ $# -eq 0 ]] && return 0
753 do 544 sed -i 's/\r$//' -- "$@" || die
754 cp "${f}" ${T}/edos2unix
755 sed 's/\r$//' ${T}/edos2unix > "${f}"
756 done
757} 545}
758
759
760##############################################################
761# START: Handle .desktop files and menu entries #
762# maybe this should be separated into a new eclass some time #
763# lanius@gentoo.org #
764##############################################################
765 546
766# Make a desktop file ! 547# Make a desktop file !
767# Great for making those icons in kde/gnome startmenu ! 548# Great for making those icons in kde/gnome startmenu !
768# Amaze your friends ! Get the women ! Join today ! 549# Amaze your friends ! Get the women ! Join today !
769# 550#
770# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 551# make_desktop_entry(<command>, [name], [icon], [type], [fields])
771# 552#
772# binary: what binary does the app run with ? 553# binary: what command does the app run with ?
773# name: the name that will show up in the menu 554# name: the name that will show up in the menu
774# icon: give your little like a pretty little icon ... 555# icon: give your little like a pretty little icon ...
775# this can be relative (to /usr/share/pixmaps) or 556# this can be relative (to /usr/share/pixmaps) or
776# a full path to an icon 557# a full path to an icon
777# type: what kind of application is this ? for categories: 558# type: what kind of application is this ? for categories:
778# http://www.freedesktop.org/Standards/desktop-entry-spec 559# http://standards.freedesktop.org/menu-spec/latest/apa.html
779# path: if your app needs to startup in a specific dir 560# fields: extra fields to append to the desktop file; a printf string
780make_desktop_entry() { 561make_desktop_entry() {
781 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 562 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
782 563
783 local exec=${1} 564 local exec=${1}
784 local name=${2:-${PN}} 565 local name=${2:-${PN}}
785 local icon=${3:-${PN}.png} 566 local icon=${3:-${PN}}
786 local type=${4} 567 local type=${4}
787 local path=${5} 568 local fields=${5}
788 569
789 if [[ -z ${type} ]] ; then 570 if [[ -z ${type} ]] ; then
790 local catmaj=${CATEGORY%%-*} 571 local catmaj=${CATEGORY%%-*}
791 local catmin=${CATEGORY##*-} 572 local catmin=${CATEGORY##*-}
792 case ${catmaj} in 573 case ${catmaj} in
793 app) 574 app)
794 case ${catmin} in 575 case ${catmin} in
576 accessibility) type=Accessibility;;
795 admin) type=System;; 577 admin) type=System;;
578 antivirus) type=System;;
579 arch) type=Archiving;;
580 backup) type=Archiving;;
796 cdr) type=DiscBurning;; 581 cdr) type=DiscBurning;;
797 dicts) type=Dictionary;; 582 dicts) type=Dictionary;;
583 doc) type=Documentation;;
798 editors) type=TextEditor;; 584 editors) type=TextEditor;;
799 emacs) type=TextEditor;; 585 emacs) type=TextEditor;;
800 emulation) type=Emulator;; 586 emulation) type=Emulator;;
801 laptop) type=HardwareSettings;; 587 laptop) type=HardwareSettings;;
802 office) type=Office;; 588 office) type=Office;;
589 pda) type=PDA;;
803 vim) type=TextEditor;; 590 vim) type=TextEditor;;
804 xemacs) type=TextEditor;; 591 xemacs) type=TextEditor;;
805 *) type=;;
806 esac 592 esac
807 ;; 593 ;;
808 594
809 dev) 595 dev)
810 type="Development" 596 type="Development"
811 ;; 597 ;;
812 598
813 games) 599 games)
814 case ${catmin} in 600 case ${catmin} in
815 action) type=ActionGame;; 601 action|fps) type=ActionGame;;
816 arcade) type=ArcadeGame;; 602 arcade) type=ArcadeGame;;
817 board) type=BoardGame;; 603 board) type=BoardGame;;
818 kid) type=KidsGame;;
819 emulation) type=Emulator;; 604 emulation) type=Emulator;;
605 kids) type=KidsGame;;
820 puzzle) type=LogicGame;; 606 puzzle) type=LogicGame;;
607 roguelike) type=RolePlaying;;
821 rpg) type=RolePlaying;; 608 rpg) type=RolePlaying;;
822 roguelike) type=RolePlaying;;
823 simulation) type=Simulation;; 609 simulation) type=Simulation;;
824 sports) type=SportsGame;; 610 sports) type=SportsGame;;
825 strategy) type=StrategyGame;; 611 strategy) type=StrategyGame;;
826 *) type=;;
827 esac 612 esac
828 type="Game;${type}" 613 type="Game;${type}"
829 ;; 614 ;;
830 615
616 gnome)
617 type="Gnome;GTK"
618 ;;
619
620 kde)
621 type="KDE;Qt"
622 ;;
623
831 mail) 624 mail)
832 type="Network;Email" 625 type="Network;Email"
833 ;; 626 ;;
834 627
835 media) 628 media)
836 case ${catmin} in 629 case ${catmin} in
630 gfx)
837 gfx) type=Graphics;; 631 type=Graphics
632 ;;
633 *)
634 case ${catmin} in
838 radio) type=Tuner;; 635 radio) type=Tuner;;
839 sound) type=Audio;; 636 sound) type=Audio;;
840 tv) type=TV;; 637 tv) type=TV;;
841 video) type=Video;; 638 video) type=Video;;
842 *) type=;; 639 esac
640 type="AudioVideo;${type}"
641 ;;
843 esac 642 esac
844 type="AudioVideo;${type}"
845 ;; 643 ;;
846 644
847 net) 645 net)
848 case ${catmin} in 646 case ${catmin} in
849 dialup) type=Dialup;; 647 dialup) type=Dialup;;
852 irc) type=IRCClient;; 650 irc) type=IRCClient;;
853 mail) type=Email;; 651 mail) type=Email;;
854 news) type=News;; 652 news) type=News;;
855 nntp) type=News;; 653 nntp) type=News;;
856 p2p) type=FileTransfer;; 654 p2p) type=FileTransfer;;
857 *) type=;; 655 voip) type=Telephony;;
858 esac 656 esac
859 type="Network;${type}" 657 type="Network;${type}"
860 ;; 658 ;;
861 659
862 sci) 660 sci)
863 case ${catmin} in 661 case ${catmin} in
864 astro*) type=Astronomy;; 662 astro*) type=Astronomy;;
865 bio*) type=Biology;; 663 bio*) type=Biology;;
866 calc*) type=Calculator;; 664 calc*) type=Calculator;;
867 chem*) type=Chemistry;; 665 chem*) type=Chemistry;;
666 elec*) type=Electronics;;
868 geo*) type=Geology;; 667 geo*) type=Geology;;
869 math*) type=Math;; 668 math*) type=Math;;
870 *) type=;; 669 physics) type=Physics;;
670 visual*) type=DataVisualization;;
871 esac 671 esac
872 type="Science;${type}" 672 type="Education;Science;${type}"
673 ;;
674
675 sys)
676 type="System"
873 ;; 677 ;;
874 678
875 www) 679 www)
876 case ${catmin} in 680 case ${catmin} in
877 client) type=WebBrowser;; 681 client) type=WebBrowser;;
878 *) type=;;
879 esac 682 esac
880 type="Network" 683 type="Network;${type}"
881 ;; 684 ;;
882 685
883 *) 686 *)
884 type= 687 type=
885 ;; 688 ;;
888 if [ "${SLOT}" == "0" ] ; then 691 if [ "${SLOT}" == "0" ] ; then
889 local desktop_name="${PN}" 692 local desktop_name="${PN}"
890 else 693 else
891 local desktop_name="${PN}-${SLOT}" 694 local desktop_name="${PN}-${SLOT}"
892 fi 695 fi
696 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
893 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 697 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
894 698
699 # Don't append another ";" when a valid category value is provided.
700 type=${type%;}${type:+;}
701
702 eshopts_push -s extglob
703 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
704 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
705 ewarn "allowed in .desktop files if the value is not an absolute path."
706 icon=${icon%.@(xpm|png|svg)}
707 fi
708 eshopts_pop
709
710 cat <<-EOF > "${desktop}"
895echo "[Desktop Entry] 711 [Desktop Entry]
896Encoding=UTF-8
897Version=0.9.2
898Name=${name} 712 Name=${name}
899Type=Application 713 Type=Application
900Comment=${DESCRIPTION} 714 Comment=${DESCRIPTION}
901Exec=${exec} 715 Exec=${exec}
902Path=${path} 716 TryExec=${exec%% *}
903Icon=${icon} 717 Icon=${icon}
904Categories=Application;${type};" > "${desktop}" 718 Categories=${type}
719 EOF
720
721 if [[ ${fields:-=} != *=* ]] ; then
722 # 5th arg used to be value to Path=
723 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
724 fields="Path=${fields}"
725 fi
726 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
905 727
906 ( 728 (
907 # wrap the env here so that the 'insinto' call 729 # wrap the env here so that the 'insinto' call
908 # doesn't corrupt the env of the caller 730 # doesn't corrupt the env of the caller
909 insinto /usr/share/applications 731 insinto /usr/share/applications
910 doins "${desktop}" 732 doins "${desktop}"
911 ) 733 ) || die "installing desktop file failed"
912} 734}
913 735
914# Make a GDM/KDM Session file 736# @FUNCTION: validate_desktop_entries
915# 737# @USAGE: [directories]
916# make_desktop_entry(<title>, <command>) 738# @MAINTAINER:
917# title: File to execute to start the Window Manager 739# Carsten Lohrke <carlo@gentoo.org>
918# command: Name of the Window Manager 740# @DESCRIPTION:
741# Validate desktop entries using desktop-file-utils
742validate_desktop_entries() {
743 if [[ -x /usr/bin/desktop-file-validate ]] ; then
744 einfo "Checking desktop entry validity"
745 local directories=""
746 for d in /usr/share/applications $@ ; do
747 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
748 done
749 if [[ -n ${directories} ]] ; then
750 for FILE in $(find ${directories} -name "*\.desktop" \
751 -not -path '*.hidden*' | sort -u 2>/dev/null)
752 do
753 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
754 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
755 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
756 done
757 fi
758 echo ""
759 else
760 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
761 fi
762}
919 763
764# @FUNCTION: make_session_desktop
765# @USAGE: <title> <command> [command args...]
766# @DESCRIPTION:
767# Make a GDM/KDM Session file. The title is the file to execute to start the
768# Window Manager. The command is the name of the Window Manager.
769#
770# You can set the name of the file via the ${wm} variable.
920make_session_desktop() { 771make_session_desktop() {
921 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 772 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
922 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 773 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
923 774
924 local title=$1 775 local title=$1
925 local command=$2 776 local command=$2
926 local desktop=${T}/${wm}.desktop 777 local desktop=${T}/${wm:-${PN}}.desktop
778 shift 2
927 779
780 cat <<-EOF > "${desktop}"
928echo "[Desktop Entry] 781 [Desktop Entry]
929Encoding=UTF-8
930Name=${title} 782 Name=${title}
931Comment=This session logs you into ${title} 783 Comment=This session logs you into ${title}
932Exec=${command} 784 Exec=${command} $*
933TryExec=${command} 785 TryExec=${command}
934Type=Application" > "${desktop}" 786 Type=XSession
787 EOF
935 788
789 (
790 # wrap the env here so that the 'insinto' call
791 # doesn't corrupt the env of the caller
936 insinto /usr/share/xsessions 792 insinto /usr/share/xsessions
937 doins "${desktop}" 793 doins "${desktop}"
794 )
938} 795}
939 796
797# @FUNCTION: domenu
798# @USAGE: <menus>
799# @DESCRIPTION:
800# Install the list of .desktop menu files into the appropriate directory
801# (/usr/share/applications).
940domenu() { 802domenu() {
803 (
804 # wrap the env here so that the 'insinto' call
805 # doesn't corrupt the env of the caller
941 local i j 806 local i j ret=0
942 insinto /usr/share/applications 807 insinto /usr/share/applications
943 for i in "$@" ; do 808 for i in "$@" ; do
944 if [[ -f ${i} ]] ; then 809 if [[ -f ${i} ]] ; then
945 doins "${i}" 810 doins "${i}"
811 ((ret+=$?))
946 elif [[ -d ${i} ]] ; then 812 elif [[ -d ${i} ]] ; then
947 for j in "${i}"/*.desktop ; do 813 for j in "${i}"/*.desktop ; do
948 doins "${j}" 814 doins "${j}"
815 ((ret+=$?))
949 done 816 done
817 else
818 ((++ret))
950 fi 819 fi
951 done 820 done
821 exit ${ret}
822 )
952} 823}
824
825# @FUNCTION: newmenu
826# @USAGE: <menu> <newname>
827# @DESCRIPTION:
828# Like all other new* functions, install the specified menu as newname.
953newmenu() { 829newmenu() {
830 (
831 # wrap the env here so that the 'insinto' call
832 # doesn't corrupt the env of the caller
954 insinto /usr/share/applications 833 insinto /usr/share/applications
955 newins "$1" "$2" 834 newins "$@"
835 )
956} 836}
957 837
838# @FUNCTION: doicon
839# @USAGE: <list of icons>
840# @DESCRIPTION:
841# Install the list of icons into the icon directory (/usr/share/pixmaps).
842# This is useful in conjunction with creating desktop/menu files.
958doicon() { 843doicon() {
844 (
845 # wrap the env here so that the 'insinto' call
846 # doesn't corrupt the env of the caller
959 local i j 847 local i j ret
960 insinto /usr/share/pixmaps 848 insinto /usr/share/pixmaps
961 for i in "$@" ; do 849 for i in "$@" ; do
962 if [[ -f ${i} ]] ; then 850 if [[ -f ${i} ]] ; then
963 doins "${i}" 851 doins "${i}"
852 ((ret+=$?))
964 elif [[ -d ${i} ]] ; then 853 elif [[ -d ${i} ]] ; then
965 for j in "${i}"/*.png ; do 854 for j in "${i}"/*.png ; do
966 doins "${j}" 855 doins "${j}"
856 ((ret+=$?))
967 done 857 done
858 else
859 ((++ret))
968 fi 860 fi
969 done 861 done
862 exit ${ret}
863 )
970} 864}
865
866# @FUNCTION: newicon
867# @USAGE: <icon> <newname>
868# @DESCRIPTION:
869# Like all other new* functions, install the specified icon as newname.
971newicon() { 870newicon() {
871 (
872 # wrap the env here so that the 'insinto' call
873 # doesn't corrupt the env of the caller
972 insinto /usr/share/pixmaps 874 insinto /usr/share/pixmaps
973 newins "$1" "$2" 875 newins "$@"
876 )
974} 877}
975
976##############################################################
977# END: Handle .desktop files and menu entries #
978##############################################################
979
980 878
981# for internal use only (unpack_pdv and unpack_makeself) 879# for internal use only (unpack_pdv and unpack_makeself)
982find_unpackable_file() { 880find_unpackable_file() {
983 local src=$1 881 local src=$1
984 if [[ -z ${src} ]] ; then 882 if [[ -z ${src} ]] ; then
994 fi 892 fi
995 [[ ! -e ${src} ]] && return 1 893 [[ ! -e ${src} ]] && return 1
996 echo "${src}" 894 echo "${src}"
997} 895}
998 896
897# @FUNCTION: unpack_pdv
898# @USAGE: <file to unpack> <size of off_t>
899# @DESCRIPTION:
999# Unpack those pesky pdv generated files ... 900# Unpack those pesky pdv generated files ...
1000# They're self-unpacking programs with the binary package stuffed in 901# They're self-unpacking programs with the binary package stuffed in
1001# the middle of the archive. Valve seems to use it a lot ... too bad 902# the middle of the archive. Valve seems to use it a lot ... too bad
1002# it seems to like to segfault a lot :(. So lets take it apart ourselves. 903# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1003# 904#
1004# Usage: unpack_pdv [file to unpack] [size of off_t]
1005# - you have to specify the off_t size ... i have no idea how to extract that 905# You have to specify the off_t size ... I have no idea how to extract that
1006# information out of the binary executable myself. basically you pass in 906# information out of the binary executable myself. Basically you pass in
1007# the size of the off_t type (in bytes) on the machine that built the pdv 907# the size of the off_t type (in bytes) on the machine that built the pdv
908# archive.
909#
1008# archive. one way to determine this is by running the following commands: 910# One way to determine this is by running the following commands:
911#
912# @CODE
1009# strings <pdv archive> | grep lseek 913# strings <pdv archive> | grep lseek
1010# strace -elseek <pdv archive> 914# strace -elseek <pdv archive>
915# @CODE
916#
1011# basically look for the first lseek command (we do the strings/grep because 917# Basically look for the first lseek command (we do the strings/grep because
1012# sometimes the function call is _llseek or something) and steal the 2nd 918# sometimes the function call is _llseek or something) and steal the 2nd
1013# parameter. here is an example: 919# parameter. Here is an example:
920#
921# @CODE
1014# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 922# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1015# lseek 923# lseek
1016# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 924# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1017# lseek(3, -4, SEEK_END) = 2981250 925# lseek(3, -4, SEEK_END) = 2981250
926# @CODE
927#
1018# thus we would pass in the value of '4' as the second parameter. 928# Thus we would pass in the value of '4' as the second parameter.
1019unpack_pdv() { 929unpack_pdv() {
1020 local src=$(find_unpackable_file $1) 930 local src=$(find_unpackable_file "$1")
1021 local sizeoff_t=$2 931 local sizeoff_t=$2
1022 932
1023 [[ -z ${src} ]] && die "Could not locate source for '$1'" 933 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1024 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 934 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1025 935
1026 local shrtsrc=$(basename "${src}") 936 local shrtsrc=$(basename "${src}")
1027 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 937 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1028 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 938 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1029 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 939 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1030 940
1031 # grab metadata for debug reasons 941 # grab metadata for debug reasons
1032 local metafile="$(emktemp)" 942 local metafile=$(emktemp)
1033 tail -c +$((${metaskip}+1)) ${src} > ${metafile} 943 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1034 944
1035 # rip out the final file name from the metadata 945 # rip out the final file name from the metadata
1036 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`" 946 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1037 datafile="`basename ${datafile}`" 947 datafile=$(basename "${datafile}")
1038 948
1039 # now lets uncompress/untar the file if need be 949 # now lets uncompress/untar the file if need be
1040 local tmpfile="$(emktemp)" 950 local tmpfile=$(emktemp)
1041 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile} 951 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1042 952
1043 local iscompressed="`file -b ${tmpfile}`" 953 local iscompressed=$(file -b "${tmpfile}")
1044 if [ "${iscompressed:0:8}" == "compress" ] ; then 954 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1045 iscompressed=1 955 iscompressed=1
1046 mv ${tmpfile}{,.Z} 956 mv ${tmpfile}{,.Z}
1047 gunzip ${tmpfile} 957 gunzip ${tmpfile}
1048 else 958 else
1049 iscompressed=0 959 iscompressed=0
1050 fi 960 fi
1051 local istar="`file -b ${tmpfile}`" 961 local istar=$(file -b "${tmpfile}")
1052 if [ "${istar:0:9}" == "POSIX tar" ] ; then 962 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1053 istar=1 963 istar=1
1054 else 964 else
1055 istar=0 965 istar=0
1056 fi 966 fi
1057 967
1085 true 995 true
1086 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 996 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1087 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 997 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1088} 998}
1089 999
1000# @FUNCTION: unpack_makeself
1001# @USAGE: [file to unpack] [offset] [tail|dd]
1002# @DESCRIPTION:
1090# Unpack those pesky makeself generated files ... 1003# Unpack those pesky makeself generated files ...
1091# They're shell scripts with the binary package tagged onto 1004# They're shell scripts with the binary package tagged onto
1092# the end of the archive. Loki utilized the format as does 1005# the end of the archive. Loki utilized the format as does
1093# many other game companies. 1006# many other game companies.
1094# 1007#
1095# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1008# If the file is not specified, then ${A} is used. If the
1096# - If the file is not specified then unpack will utilize ${A}.
1097# - If the offset is not specified then we will attempt to extract 1009# offset is not specified then we will attempt to extract
1098# the proper offset from the script itself. 1010# the proper offset from the script itself.
1099unpack_makeself() { 1011unpack_makeself() {
1100 local src_input=${1:-${A}} 1012 local src_input=${1:-${A}}
1101 local src=$(find_unpackable_file "${src_input}") 1013 local src=$(find_unpackable_file "${src_input}")
1102 local skip=$2 1014 local skip=$2
1103 local exe=$3 1015 local exe=$3
1105 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1017 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1106 1018
1107 local shrtsrc=$(basename "${src}") 1019 local shrtsrc=$(basename "${src}")
1108 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1020 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1109 if [[ -z ${skip} ]] ; then 1021 if [[ -z ${skip} ]] ; then
1110 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1022 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1111 local skip=0 1023 local skip=0
1112 exe=tail 1024 exe=tail
1113 case ${ver} in 1025 case ${ver} in
1114 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1026 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1115 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1027 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1116 ;; 1028 ;;
1117 2.0|2.0.1) 1029 2.0|2.0.1)
1118 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1030 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1119 ;; 1031 ;;
1120 2.1.1) 1032 2.1.1)
1121 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1033 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1122 let skip="skip + 1" 1034 (( skip++ ))
1123 ;; 1035 ;;
1124 2.1.2) 1036 2.1.2)
1125 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1037 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1126 let skip="skip + 1" 1038 (( skip++ ))
1127 ;; 1039 ;;
1128 2.1.3) 1040 2.1.3)
1129 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1041 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1130 let skip="skip + 1" 1042 (( skip++ ))
1131 ;; 1043 ;;
1132 2.1.4|2.1.5) 1044 2.1.4|2.1.5)
1133 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1045 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1134 skip=$(head -n ${skip} "${src}" | wc -c) 1046 skip=$(head -n ${skip} "${src}" | wc -c)
1135 exe="dd" 1047 exe="dd"
1144 esac 1056 esac
1145 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1057 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1146 fi 1058 fi
1147 case ${exe} in 1059 case ${exe} in
1148 tail) exe="tail -n +${skip} '${src}'";; 1060 tail) exe="tail -n +${skip} '${src}'";;
1149 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1061 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1150 *) die "makeself cant handle exe '${exe}'" 1062 *) die "makeself cant handle exe '${exe}'"
1151 esac 1063 esac
1152 1064
1153 # lets grab the first few bytes of the file to figure out what kind of archive it is 1065 # lets grab the first few bytes of the file to figure out what kind of archive it is
1154 local tmpfile="$(emktemp)" 1066 local filetype tmpfile=$(emktemp)
1155 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1067 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1156 local filetype="$(file -b "${tmpfile}")" 1068 filetype=$(file -b "${tmpfile}") || die
1157 case ${filetype} in 1069 case ${filetype} in
1158 *tar\ archive) 1070 *tar\ archive*)
1159 eval ${exe} | tar --no-same-owner -xf - 1071 eval ${exe} | tar --no-same-owner -xf -
1160 ;; 1072 ;;
1161 bzip2*) 1073 bzip2*)
1162 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf - 1074 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1163 ;; 1075 ;;
1173 ;; 1085 ;;
1174 esac 1086 esac
1175 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1087 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1176} 1088}
1177 1089
1090# @FUNCTION: check_license
1091# @USAGE: [license]
1092# @DESCRIPTION:
1178# Display a license for user to accept. 1093# Display a license for user to accept. If no license is
1179#
1180# Usage: check_license [license]
1181# - If the file is not specified then ${LICENSE} is used. 1094# specified, then ${LICENSE} is used.
1182check_license() { 1095check_license() {
1183 local lic=$1 1096 local lic=$1
1184 if [ -z "${lic}" ] ; then 1097 if [ -z "${lic}" ] ; then
1185 lic="${PORTDIR}/licenses/${LICENSE}" 1098 lic="${PORTDIR}/licenses/${LICENSE}"
1186 else 1099 else
1190 lic="${PWD}/${lic}" 1103 lic="${PWD}/${lic}"
1191 elif [ -e "${lic}" ] ; then 1104 elif [ -e "${lic}" ] ; then
1192 lic="${lic}" 1105 lic="${lic}"
1193 fi 1106 fi
1194 fi 1107 fi
1195 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1196 local l="`basename ${lic}`" 1108 local l="`basename ${lic}`"
1197 1109
1198 # here is where we check for the licenses the user already 1110 # here is where we check for the licenses the user already
1199 # accepted ... if we don't find a match, we make the user accept 1111 # accepted ... if we don't find a match, we make the user accept
1200 local shopts=$-
1201 local alic 1112 local alic
1202 set -o noglob #so that bash doesn't expand "*" 1113 eshopts_push -o noglob # so that bash doesn't expand "*"
1203 for alic in ${ACCEPT_LICENSE} ; do 1114 for alic in ${ACCEPT_LICENSE} ; do
1204 if [[ ${alic} == * || ${alic} == ${l} ]]; then 1115 if [[ ${alic} == ${l} ]]; then
1205 set +o noglob; set -${shopts} #reset old shell opts 1116 eshopts_pop
1206 return 0 1117 return 0
1207 fi 1118 fi
1208 done 1119 done
1209 set +o noglob; set -$shopts #reset old shell opts 1120 eshopts_pop
1121 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1210 1122
1211 local licmsg="$(emktemp)" 1123 local licmsg=$(emktemp)
1212 cat << EOF > ${licmsg} 1124 cat <<-EOF > ${licmsg}
1213********************************************************** 1125 **********************************************************
1214The following license outlines the terms of use of this 1126 The following license outlines the terms of use of this
1215package. You MUST accept this license for installation to 1127 package. You MUST accept this license for installation to
1216continue. When you are done viewing, hit 'q'. If you 1128 continue. When you are done viewing, hit 'q'. If you
1217CTRL+C out of this, the install will not run! 1129 CTRL+C out of this, the install will not run!
1218********************************************************** 1130 **********************************************************
1219 1131
1220EOF 1132 EOF
1221 cat ${lic} >> ${licmsg} 1133 cat ${lic} >> ${licmsg}
1222 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}" 1134 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1223 einfon "Do you accept the terms of this license (${l})? [yes/no] " 1135 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1224 read alic 1136 read alic
1225 case ${alic} in 1137 case ${alic} in
1232 die "Failed to accept license" 1144 die "Failed to accept license"
1233 ;; 1145 ;;
1234 esac 1146 esac
1235} 1147}
1236 1148
1149# @FUNCTION: cdrom_get_cds
1150# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1151# @DESCRIPTION:
1237# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1152# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1238# the whole 'non-interactive' policy, but damnit I want CD support ! 1153# the whole 'non-interactive' policy, but damnit I want CD support !
1239# 1154#
1240# with these cdrom functions we handle all the user interaction and 1155# With these cdrom functions we handle all the user interaction and
1241# standardize everything. all you have to do is call cdrom_get_cds() 1156# standardize everything. All you have to do is call cdrom_get_cds()
1242# and when the function returns, you can assume that the cd has been 1157# and when the function returns, you can assume that the cd has been
1243# found at CDROM_ROOT. 1158# found at CDROM_ROOT.
1244# 1159#
1160# The function will attempt to locate a cd based upon a file that is on
1161# the cd. The more files you give this function, the more cds
1162# the cdrom functions will handle.
1163#
1245# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1164# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1246# etc... if you want to give the cds better names, then just export 1165# etc... If you want to give the cds better names, then just export
1247# the CDROM_NAME_X variables before calling cdrom_get_cds(). 1166# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1167# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1168# also use the CDROM_NAME_SET bash array.
1248# 1169#
1249# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1170# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1250#
1251# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1252# - this will attempt to locate a cd based upon a file that is on
1253# the cd ... the more files you give this function, the more cds
1254# the cdrom functions will handle
1255cdrom_get_cds() { 1171cdrom_get_cds() {
1256 # first we figure out how many cds we're dealing with by 1172 # first we figure out how many cds we're dealing with by
1257 # the # of files they gave us 1173 # the # of files they gave us
1258 local cdcnt=0 1174 local cdcnt=0
1259 local f= 1175 local f=
1283 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1199 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1284 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1200 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1285 export CDROM_SET=-1 1201 export CDROM_SET=-1
1286 for f in ${CDROM_CHECK_1//:/ } ; do 1202 for f in ${CDROM_CHECK_1//:/ } ; do
1287 ((++CDROM_SET)) 1203 ((++CDROM_SET))
1288 [[ -e ${CD_ROOT}/${f} ]] && break 1204 [[ -e ${CDROM_ROOT}/${f} ]] && break
1289 done 1205 done
1290 export CDROM_MATCH=${f} 1206 export CDROM_MATCH=${f}
1291 return 1207 return
1292 fi 1208 fi
1293 1209
1303 echo 1219 echo
1304 einfo "For example:" 1220 einfo "For example:"
1305 einfo "export CD_ROOT=/mnt/cdrom" 1221 einfo "export CD_ROOT=/mnt/cdrom"
1306 echo 1222 echo
1307 else 1223 else
1224 if [[ -n ${CDROM_NAME_SET} ]] ; then
1225 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1226 cdcnt=0
1227 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1228 ((++cdcnt))
1229 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1230 done
1231 fi
1232
1308 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1233 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1309 cdcnt=0 1234 cdcnt=0
1310 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1235 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1311 ((++cdcnt)) 1236 ((++cdcnt))
1312 var="CDROM_NAME_${cdcnt}" 1237 var="CDROM_NAME_${cdcnt}"
1336 export CDROM_SET="" 1261 export CDROM_SET=""
1337 export CDROM_CURRENT_CD=0 1262 export CDROM_CURRENT_CD=0
1338 cdrom_load_next_cd 1263 cdrom_load_next_cd
1339} 1264}
1340 1265
1341# this is only used when you need access to more than one cd. 1266# @FUNCTION: cdrom_load_next_cd
1342# when you have finished using the first cd, just call this function. 1267# @DESCRIPTION:
1343# when it returns, CDROM_ROOT will be pointing to the second cd. 1268# Some packages are so big they come on multiple CDs. When you're done reading
1344# remember, you can only go forward in the cd chain, you can't go back. 1269# files off a CD and want access to the next one, just call this function.
1270# Again, all the messy details of user interaction are taken care of for you.
1271# Once this returns, just read the variable CDROM_ROOT for the location of the
1272# mounted CD. Note that you can only go forward in the CD list, so make sure
1273# you only call this function when you're done using the current CD.
1345cdrom_load_next_cd() { 1274cdrom_load_next_cd() {
1346 local var 1275 local var
1347 ((++CDROM_CURRENT_CD)) 1276 ((++CDROM_CURRENT_CD))
1348 1277
1349 unset CDROM_ROOT 1278 unset CDROM_ROOT
1366# displayed and we'll hang out here until: 1295# displayed and we'll hang out here until:
1367# (1) the file is found on a mounted cdrom 1296# (1) the file is found on a mounted cdrom
1368# (2) the user hits CTRL+C 1297# (2) the user hits CTRL+C
1369_cdrom_locate_file_on_cd() { 1298_cdrom_locate_file_on_cd() {
1370 local mline="" 1299 local mline=""
1371 local showedmsg=0 1300 local showedmsg=0 showjolietmsg=0
1372 1301
1373 while [[ -z ${CDROM_ROOT} ]] ; do 1302 while [[ -z ${CDROM_ROOT} ]] ; do
1374 local i=0 1303 local i=0
1375 local -a cdset=(${*//:/ }) 1304 local -a cdset=(${*//:/ })
1376 if [[ -n ${CDROM_SET} ]] ; then 1305 if [[ -n ${CDROM_SET} ]] ; then
1379 1308
1380 while [[ -n ${cdset[${i}]} ]] ; do 1309 while [[ -n ${cdset[${i}]} ]] ; do
1381 local dir=$(dirname ${cdset[${i}]}) 1310 local dir=$(dirname ${cdset[${i}]})
1382 local file=$(basename ${cdset[${i}]}) 1311 local file=$(basename ${cdset[${i}]})
1383 1312
1384 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do 1313 local point= node= fs= foo=
1314 while read point node fs foo ; do
1315 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1316 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1317 && continue
1318 point=${point//\040/ }
1385 [[ -d ${mline}/${dir} ]] || continue 1319 [[ ! -d ${point}/${dir} ]] && continue
1386 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then 1320 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1387 export CDROM_ROOT=${mline} 1321 export CDROM_ROOT=${point}
1388 export CDROM_SET=${i} 1322 export CDROM_SET=${i}
1389 export CDROM_MATCH=${cdset[${i}]} 1323 export CDROM_MATCH=${cdset[${i}]}
1390 return 1324 return
1391 fi 1325 done <<< "$(get_mounts)"
1392 done
1393 1326
1394 ((++i)) 1327 ((++i))
1395 done 1328 done
1396 1329
1397 echo 1330 echo
1413 showedmsg=1 1346 showedmsg=1
1414 fi 1347 fi
1415 einfo "Press return to scan for the cd again" 1348 einfo "Press return to scan for the cd again"
1416 einfo "or hit CTRL+C to abort the emerge." 1349 einfo "or hit CTRL+C to abort the emerge."
1417 echo 1350 echo
1351 if [[ ${showjolietmsg} -eq 0 ]] ; then
1352 showjolietmsg=1
1353 else
1418 einfo "If you are having trouble with the detection" 1354 ewarn "If you are having trouble with the detection"
1419 einfo "of your CD, it is possible that you do not have" 1355 ewarn "of your CD, it is possible that you do not have"
1420 einfo "Joliet support enabled in your kernel. Please" 1356 ewarn "Joliet support enabled in your kernel. Please"
1421 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1357 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1358 ebeep 5
1359 fi
1422 read || die "something is screwed with your system" 1360 read || die "something is screwed with your system"
1423 done 1361 done
1424} 1362}
1425 1363
1364# @FUNCTION: strip-linguas
1365# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1366# @DESCRIPTION:
1426# Make sure that LINGUAS only contains languages that 1367# Make sure that LINGUAS only contains languages that
1427# a package can support 1368# a package can support. The first form allows you to
1428# 1369# specify a list of LINGUAS. The -i builds a list of po
1429# usage: strip-linguas <allow LINGUAS> 1370# files found in all the directories and uses the
1430# strip-linguas -i <directories of .po files> 1371# intersection of the lists. The -u builds a list of po
1431# strip-linguas -u <directories of .po files> 1372# files found in all the directories and uses the union
1432# 1373# of the lists.
1433# The first form allows you to specify a list of LINGUAS.
1434# The -i builds a list of po files found in all the
1435# directories and uses the intersection of the lists.
1436# The -u builds a list of po files found in all the
1437# directories and uses the union of the lists.
1438strip-linguas() { 1374strip-linguas() {
1439 local ls newls 1375 local ls newls nols
1440 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1376 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1441 local op=$1; shift 1377 local op=$1; shift
1442 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1378 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1443 local d f 1379 local d f
1444 for d in "$@" ; do 1380 for d in "$@" ; do
1445 if [[ ${op} == "-u" ]] ; then 1381 if [[ ${op} == "-u" ]] ; then
1446 newls=${ls} 1382 newls=${ls}
1447 else 1383 else
1448 newls="" 1384 newls=""
1449 fi 1385 fi
1450 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1386 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1451 if [[ ${op} == "-i" ]] ; then 1387 if [[ ${op} == "-i" ]] ; then
1452 [[ ${ls/ ${f} /} != ${ls} ]] && newls="${newls} ${f}" 1388 has ${f} ${ls} && newls="${newls} ${f}"
1453 else 1389 else
1454 [[ ${ls/ ${f} /} == ${ls} ]] && newls="${newls} ${f}" 1390 has ${f} ${ls} || newls="${newls} ${f}"
1455 fi 1391 fi
1456 done 1392 done
1457 ls=${newls} 1393 ls=${newls}
1458 done 1394 done
1459 ls=${ls//.po}
1460 else 1395 else
1461 ls=$@ 1396 ls="$@"
1462 fi 1397 fi
1463 1398
1464 ls=" ${ls} " 1399 nols=""
1465 newls="" 1400 newls=""
1466 for f in ${LINGUAS} ; do 1401 for f in ${LINGUAS} ; do
1467 if [[ ${ls/ ${f} /} != ${ls} ]] ; then 1402 if has ${f} ${ls} ; then
1468 newls="${newls} ${f}" 1403 newls="${newls} ${f}"
1469 else 1404 else
1470 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1405 nols="${nols} ${f}"
1471 fi 1406 fi
1472 done 1407 done
1473 if [[ -z ${newls} ]] ; then 1408 [[ -n ${nols} ]] \
1474 export LINGUAS="" 1409 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1475 else
1476 export LINGUAS=${newls:1} 1410 export LINGUAS=${newls:1}
1477 fi
1478} 1411}
1479 1412
1480# moved from kernel.eclass since they are generally useful outside of 1413# @FUNCTION: preserve_old_lib
1481# kernel.eclass -iggy (20041002) 1414# @USAGE: <libs to preserve> [more libs]
1482 1415# @DESCRIPTION:
1483# the following functions are useful in kernel module ebuilds, etc.
1484# for an example see ivtv or drbd ebuilds
1485
1486# set's ARCH to match what the kernel expects
1487set_arch_to_kernel() {
1488 i=10
1489 while ((i--)) ; do
1490 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1491 done
1492 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1493 case ${ARCH} in
1494 x86) export ARCH="i386";;
1495 amd64) export ARCH="x86_64";;
1496 hppa) export ARCH="parisc";;
1497 mips) export ARCH="mips";;
1498 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1499 *) export ARCH="${ARCH}";;
1500 esac
1501}
1502
1503# set's ARCH back to what portage expects
1504set_arch_to_portage() {
1505 i=10
1506 while ((i--)) ; do
1507 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1508 done
1509 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1510}
1511
1512# Jeremy Huddleston <eradicator@gentoo.org>:
1513# preserve_old_lib /path/to/libblah.so.0
1514# preserve_old_lib_notify /path/to/libblah.so.0
1515#
1516# These functions are useful when a lib in your package changes --soname. Such 1416# These functions are useful when a lib in your package changes ABI SONAME.
1517# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1417# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1518# would break packages that link against it. Most people get around this 1418# would break packages that link against it. Most people get around this
1519# by using the portage SLOT mechanism, but that is not always a relevant 1419# by using the portage SLOT mechanism, but that is not always a relevant
1520# solution, so instead you can add the following to your ebuilds: 1420# solution, so instead you can call this from pkg_preinst. See also the
1521# 1421# preserve_old_lib_notify function.
1522# src_install() {
1523# ...
1524# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1525# ...
1526# }
1527#
1528# pkg_postinst() {
1529# ...
1530# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1531# ...
1532# }
1533
1534preserve_old_lib() { 1422preserve_old_lib() {
1535 LIB=$1 1423 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1424 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1425 die "Invalid preserve_old_lib() usage"
1426 fi
1427 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1536 1428
1537 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1429 # let portage worry about it
1538 SONAME=`basename ${LIB}` 1430 has preserve-libs ${FEATURES} && return 0
1539 DIRNAME=`dirname ${LIB}`
1540 1431
1541 dodir ${DIRNAME} 1432 local lib dir
1542 cp ${ROOT}${LIB} ${D}${DIRNAME} 1433 for lib in "$@" ; do
1434 [[ -e ${ROOT}/${lib} ]] || continue
1435 dir=${lib%/*}
1436 dodir ${dir} || die "dodir ${dir} failed"
1437 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1543 touch ${D}${LIB} 1438 touch "${D}"/${lib}
1544 fi 1439 done
1545} 1440}
1546 1441
1442# @FUNCTION: preserve_old_lib_notify
1443# @USAGE: <libs to notify> [more libs]
1444# @DESCRIPTION:
1445# Spit helpful messages about the libraries preserved by preserve_old_lib.
1547preserve_old_lib_notify() { 1446preserve_old_lib_notify() {
1548 LIB=$1 1447 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1448 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1449 die "Invalid preserve_old_lib_notify() usage"
1450 fi
1549 1451
1550 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1452 # let portage worry about it
1551 SONAME=`basename ${LIB}` 1453 has preserve-libs ${FEATURES} && return 0
1552 1454
1455 local lib notice=0
1456 for lib in "$@" ; do
1457 [[ -e ${ROOT}/${lib} ]] || continue
1458 if [[ ${notice} -eq 0 ]] ; then
1459 notice=1
1553 ewarn "An old version of an installed library was detected on your system." 1460 ewarn "Old versions of installed libraries were detected on your system."
1554 ewarn "In order to avoid breaking packages that link against it, this older version" 1461 ewarn "In order to avoid breaking packages that depend on these old libs,"
1555 ewarn "is not being removed. In order to make full use of this newer version," 1462 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1556 ewarn "you will need to execute the following command:" 1463 ewarn "in order to remove these old dependencies. If you do not have this"
1557 ewarn " revdep-rebuild --soname ${SONAME}" 1464 ewarn "helper program, simply emerge the 'gentoolkit' package."
1465 ewarn
1466 fi
1467 # temp hack for #348634 #357225
1468 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1469 ewarn " # revdep-rebuild --library '${lib}'"
1470 done
1471 if [[ ${notice} -eq 1 ]] ; then
1558 ewarn 1472 ewarn
1559 ewarn "After doing that, you can safely remove ${LIB}" 1473 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1560 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1474 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1475 for lib in "$@" ; do
1476 ewarn " # rm '${lib}'"
1477 done
1561 fi 1478 fi
1562} 1479}
1563 1480
1564# Hack for people to figure out if a package was built with 1481# @FUNCTION: built_with_use
1565# certain USE flags 1482# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1483# @DESCRIPTION:
1566# 1484#
1567# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1485# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1568# ex: built_with_use xchat gtk2
1569# 1486#
1570# Flags: -a all USE flags should be utilized 1487# A temporary hack until portage properly supports DEPENDing on USE
1571# -o at least one USE flag should be utilized 1488# flags being enabled in packages. This will check to see if the specified
1572# Note: the default flag is '-a' 1489# DEPEND atom was built with the specified list of USE flags. The
1490# --missing option controls the behavior if called on a package that does
1491# not actually support the defined USE flags (aka listed in IUSE).
1492# The default is to abort (call die). The -a and -o flags control
1493# the requirements of the USE flags. They correspond to "and" and "or"
1494# logic. So the -a flag means all listed USE flags must be enabled
1495# while the -o flag means at least one of the listed IUSE flags must be
1496# enabled. The --hidden option is really for internal use only as it
1497# means the USE flag we're checking is hidden expanded, so it won't be found
1498# in IUSE like normal USE flags.
1499#
1500# Remember that this function isn't terribly intelligent so order of optional
1501# flags matter.
1573built_with_use() { 1502built_with_use() {
1503 local hidden="no"
1504 if [[ $1 == "--hidden" ]] ; then
1505 hidden="yes"
1506 shift
1507 fi
1508
1509 local missing_action="die"
1510 if [[ $1 == "--missing" ]] ; then
1511 missing_action=$2
1512 shift ; shift
1513 case ${missing_action} in
1514 true|false|die) ;;
1515 *) die "unknown action '${missing_action}'";;
1516 esac
1517 fi
1518
1574 local opt=$1 1519 local opt=$1
1575 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1520 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1576 1521
1577 local PKG=$(best_version $1) 1522 local PKG=$(best_version $1)
1523 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1578 shift 1524 shift
1579 1525
1580 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1526 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1527 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1581 1528
1582 # if the USE file doesnt exist, assume the $PKG is either 1529 # if the IUSE file doesn't exist, the read will error out, we need to handle
1583 # injected or package.provided 1530 # this gracefully
1584 [[ ! -e ${USEFILE} ]] && return 0 1531 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1532 case ${missing_action} in
1533 true) return 0;;
1534 false) return 1;;
1535 die) die "Unable to determine what USE flags $PKG was built with";;
1536 esac
1537 fi
1538
1539 if [[ ${hidden} == "no" ]] ; then
1540 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1541 # Don't check USE_EXPAND #147237
1542 local expand
1543 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1544 if [[ $1 == ${expand}_* ]] ; then
1545 expand=""
1546 break
1547 fi
1548 done
1549 if [[ -n ${expand} ]] ; then
1550 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1551 case ${missing_action} in
1552 true) return 0;;
1553 false) return 1;;
1554 die) die "$PKG does not actually support the $1 USE flag!";;
1555 esac
1556 fi
1557 fi
1558 fi
1585 1559
1586 local USE_BUILT=$(<${USEFILE}) 1560 local USE_BUILT=$(<${USEFILE})
1587 while [[ $# -gt 0 ]] ; do 1561 while [[ $# -gt 0 ]] ; do
1588 if [[ ${opt} = "-o" ]] ; then 1562 if [[ ${opt} = "-o" ]] ; then
1589 has $1 ${USE_BUILT} && return 0 1563 has $1 ${USE_BUILT} && return 0
1593 shift 1567 shift
1594 done 1568 done
1595 [[ ${opt} = "-a" ]] 1569 [[ ${opt} = "-a" ]]
1596} 1570}
1597 1571
1572# @FUNCTION: epunt_cxx
1573# @USAGE: [dir to scan]
1574# @DESCRIPTION:
1598# Many configure scripts wrongly bail when a C++ compiler 1575# Many configure scripts wrongly bail when a C++ compiler could not be
1599# could not be detected. #73450 1576# detected. If dir is not specified, then it defaults to ${S}.
1577#
1578# http://bugs.gentoo.org/73450
1600epunt_cxx() { 1579epunt_cxx() {
1601 local dir=$1 1580 local dir=$1
1602 [[ -z ${dir} ]] && dir=${S} 1581 [[ -z ${dir} ]] && dir=${S}
1603 ebegin "Removing useless C++ checks" 1582 ebegin "Removing useless C++ checks"
1604 local f 1583 local f
1605 for f in $(find ${dir} -name configure) ; do 1584 find "${dir}" -name configure | while read f ; do
1606 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1585 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1607 done 1586 done
1608 eend 0 1587 eend 0
1609} 1588}
1610 1589
1611# dopamd <file> [more files] 1590# @FUNCTION: make_wrapper
1612# 1591# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1613# Install pam auth config file in /etc/pam.d 1592# @DESCRIPTION:
1614dopamd() { 1593# Create a shell wrapper script named wrapper in installpath
1615 [[ -z $1 ]] && die "dopamd requires at least one argument" 1594# (defaults to the bindir) to execute target (default of wrapper) by
1616 1595# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1617 use pam || return 0 1596# libpaths followed by optionally changing directory to chdir.
1618
1619 INSDESTTREE=/etc/pam.d \
1620 doins "$@" || die "failed to install $@"
1621}
1622# newpamd <old name> <new name>
1623#
1624# Install pam file <old name> as <new name> in /etc/pam.d
1625newpamd() {
1626 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1627
1628 use pam || return 0
1629
1630 INSDESTTREE=/etc/pam.d \
1631 newins "$1" "$2" || die "failed to install $1 as $2"
1632}
1633
1634# make a wrapper script ...
1635# NOTE: this was originally games_make_wrapper, but I noticed other places where
1636# this could be used, so I have moved it here and made it not games-specific
1637# -- wolf31o2
1638# $1 == wrapper name
1639# $2 == binary to run
1640# $3 == directory to chdir before running binary
1641# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1642# $5 == path for wrapper
1643make_wrapper() { 1597make_wrapper() {
1644 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1598 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1645 local tmpwrapper=$(emktemp) 1599 local tmpwrapper=$(emktemp)
1646 # We don't want to quote ${bin} so that people can pass complex 1600 # We don't want to quote ${bin} so that people can pass complex
1647 # things as $bin ... "./someprog --args" 1601 # things as $bin ... "./someprog --args"
1657fi 1611fi
1658exec ${bin} "\$@" 1612exec ${bin} "\$@"
1659EOF 1613EOF
1660 chmod go+rx "${tmpwrapper}" 1614 chmod go+rx "${tmpwrapper}"
1661 if [[ -n ${path} ]] ; then 1615 if [[ -n ${path} ]] ; then
1616 (
1662 exeinto "${path}" 1617 exeinto "${path}"
1663 newexe "${tmpwrapper}" "${wrapper}" 1618 newexe "${tmpwrapper}" "${wrapper}"
1619 ) || die
1664 else 1620 else
1665 newbin "${tmpwrapper}" "${wrapper}" 1621 newbin "${tmpwrapper}" "${wrapper}" || die
1666 fi 1622 fi
1667} 1623}
1624
1625# @FUNCTION: path_exists
1626# @USAGE: [-a|-o] <paths>
1627# @DESCRIPTION:
1628# Check if the specified paths exist. Works for all types of paths
1629# (files/dirs/etc...). The -a and -o flags control the requirements
1630# of the paths. They correspond to "and" and "or" logic. So the -a
1631# flag means all the paths must exist while the -o flag means at least
1632# one of the paths must exist. The default behavior is "and". If no
1633# paths are specified, then the return value is "false".
1634path_exists() {
1635 local opt=$1
1636 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1637
1638 # no paths -> return false
1639 # same behavior as: [[ -e "" ]]
1640 [[ $# -eq 0 ]] && return 1
1641
1642 local p r=0
1643 for p in "$@" ; do
1644 [[ -e ${p} ]]
1645 : $(( r += $? ))
1646 done
1647
1648 case ${opt} in
1649 -a) return $(( r != 0 )) ;;
1650 -o) return $(( r == $# )) ;;
1651 esac
1652}
1653
1654# @FUNCTION: in_iuse
1655# @USAGE: <flag>
1656# @DESCRIPTION:
1657# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1658# as necessary.
1659#
1660# Note that this function should not be used in the global scope.
1661in_iuse() {
1662 debug-print-function ${FUNCNAME} "${@}"
1663 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1664
1665 local flag=${1}
1666 local liuse=( ${IUSE} )
1667
1668 has "${flag}" "${liuse[@]#[+-]}"
1669}
1670
1671# @FUNCTION: use_if_iuse
1672# @USAGE: <flag>
1673# @DESCRIPTION:
1674# Return true if the given flag is in USE and IUSE.
1675#
1676# Note that this function should not be used in the global scope.
1677use_if_iuse() {
1678 in_iuse $1 || return 1
1679 use $1
1680}
1681
1682# @FUNCTION: usex
1683# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1684# @DESCRIPTION:
1685# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1686# otherwise echo [false output][false suffix] (defaults to "no").
1687usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963

Legend:
Removed from v.1.223  
changed lines
  Added in v.1.370

  ViewVC Help
Powered by ViewVC 1.1.20